1 #!/bin/sh -- # no runable script, just for vi
3 # we all like colorful messages
4 if expr match
"$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev
/null
&& \
5 expr match
"$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev
/null
; then
6 CERROR
="\e[1;31m" # red
7 CWARNING
="\e[1;33m" # yellow
8 CMSG
="\e[1;32m" # green
9 CINFO
="\e[1;96m" # light blue
10 CDEBUG
="\e[1;94m" # blue
11 CNORMAL
="\e[0;39m" # default system console color
12 CDONE
="\e[1;32m" # green
13 CPASS
="\e[1;32m" # green
14 CFAIL
="\e[1;31m" # red
15 CCMD
="\e[1;35m" # pink
18 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
19 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
20 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
21 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
22 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
23 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
24 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
25 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
26 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
27 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
30 echo -n "${CINFO}$1${CCMD} " >&2;
31 echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " >&2;
33 if [ -n "$1" ]; then shift; else break; fi
35 echo -n "…${CNORMAL} " >&2;
37 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
38 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
39 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
41 # enable / disable Debugging
42 MSGLEVEL
=${MSGLEVEL:-3}
43 if [ $MSGLEVEL -le 0 ]; then
46 if [ $MSGLEVEL -le 1 ]; then
50 if [ $MSGLEVEL -le 2 ]; then
54 msgpass
() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
55 msgskip
() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
56 if [ -n "$CFAIL" ]; then
57 msgfail
() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
59 msgfail
() { echo -n " ###FAILED###" >&2; }
62 if [ $MSGLEVEL -le 3 ]; then
66 if [ $MSGLEVEL -le 4 ]; then
71 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
72 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
73 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
74 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
75 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
78 echo "${CDONE}DONE${CNORMAL}" >&2;
83 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
84 if [ -f .
/aptconfig.conf
]; then
85 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
86 elif [ -f ..
/aptconfig.conf
]; then
87 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
89 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
92 aptconfig
() { runapt apt
-config $
*; }
93 aptcache
() { runapt apt
-cache $
*; }
94 aptget
() { runapt apt
-get $
*; }
95 aptftparchive
() { runapt apt
-ftparchive $
*; }
96 aptkey
() { runapt apt
-key $
*; }
97 aptmark
() { runapt apt
-mark $
*; }
99 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
102 if [ -f .
/aptconfig.conf
]; then
103 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
104 elif [ -f ..
/aptconfig.conf
]; then
105 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
107 LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
112 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which gdb) ${BUILDDIRECTORY}/$1
116 CURRENTTRAP
="$CURRENTTRAP $1"
117 trap "$CURRENTTRAP exit;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
121 TMPWORKINGDIRECTORY
=$(mktemp -d)
122 TESTDIRECTORY
=$(readlink -f $(dirname $0))
123 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
124 BUILDDIRECTORY
="${TESTDIRECTORY}/../../build/bin"
125 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
126 local OLDWORKINGDIRECTORY
=$(pwd)
127 addtrap
"cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
128 cd $TMPWORKINGDIRECTORY
129 mkdir rootdir aptarchive keys
131 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
132 mkdir -p var
/cache var
/lib var
/log
133 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
134 touch var
/lib
/dpkg
/available
136 ln -s ${BUILDDIRECTORY}/methods usr
/lib
/apt
/methods
138 local PACKAGESFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
139 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
140 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
142 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
143 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
144 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive
/Sources
146 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys
/
147 ln -s ${TMPWORKINGDIRECTORY}/keys
/joesixpack.pub rootdir
/etc
/apt
/trusted.gpg.d
/joesixpack.gpg
148 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
149 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
150 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
151 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
152 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
153 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
154 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
155 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
156 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
157 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
158 if ! $(which dpkg) --assert-multi-arch 2>&1 > /dev
/null
; then
159 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf
# Added to test multiarch before dpkg is ready for it…
161 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
162 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
164 export PATH
="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
169 if [ "$1" = "native" -o -z "$1" ]; then
170 eval `aptconfig shell ARCH APT::Architecture`
171 if [ -n "$ARCH" ]; then
174 dpkg
--print-architecture
182 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
185 configarchitecture
() {
186 local CONFFILE
=rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
188 echo "APT::Architecture \"$(getarchitecture $1)\";" > $CONFFILE
190 while [ -n "$1" ]; do
191 echo "APT::Architectures:: \"$(getarchitecture $1)\";" >> $CONFFILE
198 if [ ! -e rootdir
/var
/lib
/dpkg
/status
]; then
199 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
200 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
201 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
203 echo -n > rootdir/var/lib/dpkg/status
206 if $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
207 local ARCHS="$(getarchitectures)"
208 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
209 DPKGARCH="$(dpkg --print-architecture)"
210 for ARCH in ${ARCHS}; do
211 if [ "${ARCH}" != "${DPKGARCH}" ]; then dpkg --add-architecture ${ARCH}; fi
213 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
214 # dpkg doesn't really check the version as long as it is fully installed,
215 # but just to be sure we choose one above the required version
216 insertinstalledpackage 'dpkg' "all
" '1.16.2+fake'
222 setupsimplenativepackage() {
226 local RELEASE="${4:-unstable}"
227 local DEPENDENCIES="$5"
228 local DESCRIPTION="$6"
229 local SECTION="${7:-others}"
231 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
234 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
236 local BUILDDIR=incoming/${NAME}-${VERSION}
237 mkdir -p ${BUILDDIR}/debian/source
239 echo "* most suckless software product ever
" > FEATURES
240 test -e debian/copyright || echo "Copyleft by Joe Sixpack
$(date +%Y)" > debian/copyright
241 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency
=low
245 -- Joe Sixpack
<joe@example.org
> $(date -R)" > debian/changelog
246 test -e debian/control || echo "Source
: $NAME
249 Maintainer
: Joe Sixpack
<joe@example.org
>
250 Build
-Depends: debhelper
(>= 7)
251 Standards
-Version: 3.9.1
253 Package
: $NAME" > debian/control
254 if [ "$ARCH" = 'all' ]; then
255 echo "Architecture
: all
" >> debian/control
257 echo "Architecture
: any
" >> debian/control
259 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
260 if [ -z "$DESCRIPTION" ]; then
261 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
262 If you
find such a package installed on your system
,
263 YOU did something horribly wrong
! They are autogenerated
264 und used only by testcases
for APT and surf no other propose…
" >> debian/control
266 echo "Description
: $DESCRIPTION" >> debian/control
268 test -e debian/compat || echo "7" > debian/compat
269 test -e debian/source/format || echo "3.0 (native
)" > debian/source/format
270 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
274 buildsimplenativepackage() {
278 local RELEASE="${4:-unstable}"
279 local DEPENDENCIES="$5"
280 local DESCRIPTION="$6"
281 local SECTION="${7:-others}"
282 local PRIORITY="${8:-optional}"
284 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
287 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
289 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
291 msgninfo "Build package
${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}…
"
292 mkdir -p $BUILDDIR/debian/source
293 echo "* most suckless software product ever
" > ${BUILDDIR}/FEATURES
295 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
297 echo "Copyleft by Joe Sixpack
$(date +%Y)" > ${BUILDDIR}/debian/copyright
298 echo "$NAME ($VERSION) $RELEASE; urgency
=low
302 -- Joe Sixpack
<joe@example.org
> $(date -R)" > ${BUILDDIR}/debian/changelog
306 Maintainer
: Joe Sixpack
<joe@example.org
>
307 Standards
-Version: 3.9.1
309 Package
: $NAME" > ${BUILDDIR}/debian/control
310 if [ "$ARCH" = 'all' ]; then
311 echo "Architecture
: all
" >> ${BUILDDIR}/debian/control
313 echo "Architecture
: any
" >> ${BUILDDIR}/debian/control
315 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
316 if [ -z "$DESCRIPTION" ]; then
317 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
318 If you
find such a package installed on your system
,
319 YOU did something horribly wrong
! They are autogenerated
320 und used only by testcases
for APT and surf no other propose…
" >> ${BUILDDIR}/debian/control
322 echo "Description
: $DESCRIPTION" >> ${BUILDIR}/debian/control
324 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
325 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
327 echo "pool
/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
330 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
331 rm -rf ${BUILDDIR}/debian
/tmp
332 mkdir -p ${BUILDDIR}/debian
/tmp
/DEBIAN
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
333 cp ${BUILDDIR}/debian
/copyright
${BUILDDIR}/debian
/changelog
${BUILDDIR}/FEATURES
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME}
334 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
/${NAME}-${arch}
335 (cd ${BUILDDIR}; dpkg
-gencontrol -DArchitecture=$arch)
336 (cd ${BUILDDIR}/debian
/tmp
; md5sum $(find usr/ -type f) > DEBIAN
/md5sums
)
338 dpkg
-deb --build ${BUILDDIR}/debian
/tmp
${BUILDDIR}/..
2> /dev
/null
> /dev
/null
339 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/..
/${RELEASE}.
${DISTSECTION}.pkglist
342 mkdir -p ${BUILDDIR}/..
/${NAME}_
${VERSION}
343 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}/
344 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}.changelog
353 local ARCH
=$(getarchitecture $4)
354 msgninfo
"Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
356 if [ "$ARCH" = "all" ]; then
357 ARCH
="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
359 local BUILT
="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
360 local PKGS
="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
361 local SRCS
="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
364 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.pkglist
367 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.srclist
373 if [ -d incoming
]; then
374 buildaptarchivefromincoming $
*
376 buildaptarchivefromfiles $
*
380 createaptftparchiveconfig
() {
381 local ARCHS
="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
382 if [ -z "$ARCHS" ]; then
383 # the pool is empty, so we will operate on faked packages - let us use the configured archs
384 ARCHS
="$(getarchitectures)"
387 ArchiveDir "' >> ftparchive.conf
388 echo -n $(readlink -f .) >> ftparchive.conf
390 CacheDir "' >> ftparchive.conf
391 echo -n $(readlink -f ..) >> ftparchive.conf
393 FileListDir "' >> ftparchive.conf
394 echo -n $(readlink -f pool/) >> ftparchive.conf
398 Packages::Compress ". gzip bzip2 lzma xz";
399 Sources::Compress ". gzip bzip2 lzma xz";
400 Contents::Compress ". gzip bzip2 lzma xz";
401 Translation::Compress ". gzip bzip2 lzma xz";
402 LongDescription "false";
406 SrcDirectory "pool/";
412 Label "apttestcases";
414 Description "repository with dummy packages";
415 Architectures "' >> ftparchive.conf
416 echo -n "$ARCHS" >> ftparchive.conf
420 };' >> ftparchive.conf
421 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
422 echo -n 'tree "dists/' >> ftparchive.conf
423 echo -n "$DIST" >> ftparchive.conf
425 Architectures "' >> ftparchive.conf
426 echo -n "$ARCHS" >> ftparchive.conf
428 FileList "' >> ftparchive.conf
429 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
431 SourceFileList "' >> ftparchive.conf
432 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
434 Sections "' >> ftparchive.conf
435 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
437 };' >> ftparchive.conf
441 buildaptftparchivedirectorystructure
() {
442 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
443 for DIST
in $DISTS; do
444 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
445 for SECTION
in $SECTIONS; do
446 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
447 for ARCH
in $ARCHS; do
448 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
450 mkdir -p dists
/${DIST}/${SECTION}/source
451 mkdir -p dists
/${DIST}/${SECTION}/i18n
461 local DEPENDENCIES
="$5"
462 local PRIORITY
="${6:-optional}"
464 for arch
in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
465 if [ "$arch" = "all" ]; then
466 ARCHS
="$(getarchitectures)"
470 for BUILDARCH
in $ARCHS; do
471 local PPATH
="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
472 mkdir -p $PPATH aptarchive
/dists
/${RELEASE}/main
/source
473 touch aptarchive
/dists
/${RELEASE}/main
/source
/Sources
474 local FILE
="${PPATH}/Packages"
479 Maintainer: Joe Sixpack <joe@example.org>
482 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
483 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
484 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
485 If you find such a package installed on your system,
486 YOU did something horribly wrong! They are autogenerated
487 und used only by testcases for APT and surf no other propose…
498 local DEPENDENCIES
="$5"
500 local SPATH
="aptarchive/dists/${RELEASE}/main/source"
502 local FILE
="${SPATH}/Sources"
506 Maintainer: Joe Sixpack <joe@example.org>
507 Architecture: $ARCH" >> $FILE
508 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
510 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
511 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz" >> $FILE
514 insertinstalledpackage
() {
518 local DEPENDENCIES
="$4"
519 local PRIORITY
="${5:-optional}"
520 local FILE
='rootdir/var/lib/dpkg/status'
521 local INFO
='rootdir/var/lib/dpkg/info'
522 for arch
in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
524 Status: install ok installed
528 Maintainer: Joe Sixpack <joe@example.org>
530 Version: $VERSION" >> $FILE
531 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
532 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
533 If you find such a package installed on your system,
534 YOU did something horribly wrong! They are autogenerated
535 und used only by testcases for APT and surf no other propose…
537 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
538 echo -n > ${INFO}/${NAME}:${arch}.list
540 echo -n > ${INFO}/${NAME}.list
546 buildaptarchivefromincoming
() {
547 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
549 [ -e pool
] || ln -s ..
/incoming pool
550 [ -e ftparchive.conf
] || createaptftparchiveconfig
551 [ -e dists
] || buildaptftparchivedirectorystructure
552 msgninfo
"\tGenerate Packages, Sources and Contents files… "
553 aptftparchive
-qq generate ftparchive.conf
559 buildaptarchivefromfiles
() {
560 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
561 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
562 msgninfo
"\t${line} file… "
563 cat ${line} | gzip > ${line}.gz
564 cat ${line} | bzip2 > ${line}.bz2
565 cat ${line} | xz
--format=lzma
> ${line}.lzma
566 cat ${line} | xz
> ${line}.xz
572 # can be overridden by testcases for their pleasure
573 getcodenamefromsuite
() { echo -n "$1"; }
574 getreleaseversionfromsuite
() { true
; }
575 getlabelfromsuite
() { true
; }
577 generatereleasefiles
() {
578 # $1 is the Date header and $2 is the ValidUntil header to be set
579 # both should be given in notation date/touch can understand
580 msgninfo
"\tGenerate Release files… "
581 if [ -e aptarchive
/dists
]; then
582 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
583 local SUITE
="$(echo "$dir" | cut -d'/' -f 4)"
584 local CODENAME
="$(getcodenamefromsuite $SUITE)"
585 local VERSION
="$(getreleaseversionfromsuite $SUITE)"
586 local LABEL
="$(getlabelfromsuite $SUITE)"
587 if [ -n "$VERSION" ]; then
588 VERSION
="-o APT::FTPArchive::Release::Version=${VERSION}"
590 if [ -n "$LABEL" ]; then
591 LABEL
="-o APT::FTPArchive::Release::Label=${LABEL}"
593 aptftparchive
-qq release
$dir \
594 -o APT
::FTPArchive
::Release
::Suite
="${SUITE}" \
595 -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" \
598 | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
599 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
601 NotAutomatic: yes' $dir/Release
603 if [ -n "$1" -a "$1" != "now" ]; then
604 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
608 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
612 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
614 if [ -n "$1" -a "$1" != "now" ]; then
615 for release
in $(find ./aptarchive -name 'Release'); do
616 touch -d "$1" $release
622 setupdistsaptarchive
() {
623 local APTARCHIVE
=$(readlink -f ./aptarchive)
624 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
625 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
626 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
627 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
628 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
629 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
630 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
635 setupflataptarchive
() {
636 local APTARCHIVE
=$(readlink -f ./aptarchive)
637 if [ -f ${APTARCHIVE}/Packages
]; then
638 msgninfo
"\tadd deb sources.list line… "
639 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
642 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
644 if [ -f ${APTARCHIVE}/Sources
]; then
645 msgninfo
"\tadd deb-src sources.list line… "
646 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
649 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
655 if [ -e aptarchive
/dists
]; then
661 msgninfo
"\tSync APT's cache with the archive… "
667 local SIGNER
="${1:-Joe Sixpack}"
668 msgninfo
"\tSign archive with $SIGNER key… "
670 for KEY
in $(find keys/ -name '*.sec'); do
671 SECKEYS
="$SECKEYS --secret-keyring $KEY"
674 for KEY
in $(find keys/ -name '*.pub'); do
675 PUBKEYS
="$PUBKEYS --keyring $KEY"
677 for RELEASE
in $(find aptarchive/ -name Release); do
678 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg
${RELEASE}
679 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
684 changetowebserver
() {
685 if which weborf
> /dev
/null
; then
686 weborf
-xb aptarchive
/ 2>&1 > /dev
/null
&
688 elif which gatling
> /dev
/null
; then
690 gatling
-p 8080 -F -S 2>&1 > /dev
/null
&
693 elif which lighttpd
> /dev
/null
; then
694 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
696 server.stat-cache-engine = \"disable\"" > lighttpd.conf
697 lighttpd
-t -f lighttpd.conf
>/dev
/null
|| msgdie
'Can not change to webserver: our lighttpd config is invalid'
698 lighttpd
-D -f lighttpd.conf
2>/dev
/null
>/dev
/null
&
701 msgdie
'You have to install weborf or lighttpd first'
704 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
705 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
706 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
712 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
713 if [ -n "$DIFFTEXT" ]; then
725 msgtest
"Test for correctness of file" "$FILE"
727 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
729 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
734 local COMPAREFILE
=$(mktemp)
735 addtrap
"rm $COMPAREFILE;"
736 echo "$1" > $COMPAREFILE
738 msgtest
"Test for equality of" "$*"
739 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
743 local COMPAREFILE1
=$(mktemp)
744 local COMPAREFILE2
=$(mktemp)
745 local COMPAREAGAINST
=$(mktemp)
746 addtrap
"rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
747 echo "$1" > $COMPAREFILE1
748 echo "$2" > $COMPAREFILE2
750 msgtest
"Test for equality OR of" "$*"
751 $
* 2>&1 1> $COMPAREAGAINST
752 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
753 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
754 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
755 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
760 local VIRTUAL
="N: Can't select versions from package '$1' as it is purely virtual"
763 while [ -n "$1" ]; do
765 N: Can't select versions from package '$1' as it is purely virtual"
766 PACKAGE
="${PACKAGE} $1"
769 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
771 N: No packages found"
772 local COMPAREFILE
=$(mktemp)
773 addtrap
"rm $COMPAREFILE;"
774 local ARCH
="$(getarchitecture 'native')"
775 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
776 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
780 msgtest
"Test for non-existent packages" "apt-cache show $*"
781 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
782 if [ -n "$SHOWPKG" ]; then
791 testdpkginstalled
() {
792 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
793 local PKGS
="$(dpkg -l $* | grep '^i' | wc -l)"
794 if [ "$PKGS" != $# ]; then
796 dpkg
-l $
* | grep '^[a-z]'
803 testdpkgnotinstalled
() {
804 msgtest
"Test for correctly not-installed package(s) with" "dpkg -l $*"
805 local PKGS
="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
806 if [ "$PKGS" != 0 ]; then
808 dpkg
-l $
* | grep '^[a-z]'
816 local COMPAREFILE
=$(mktemp)
817 addtrap
"rm $COMPAREFILE;"
819 msgtest
'Test for correctly marked as auto-installed' "$*"
820 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
822 msgtest
'Test for correctly marked as auto-installed' 'no package'
823 echo -n > $COMPAREFILE
825 aptmark showauto
2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
829 echo "STOPPED execution. Press enter to continue"